<?php
/**
 *	Loaderclass to allow access to all classes required
 *
 * @author Schoenmann Guenter
 * @version 1.0.0.0
 */
class inoplugs_fw_loader_trial
{
	static $classes_php;
	static $classes_html;

	public function __construct()
	{
		self::$classes_php = array('inoplugs_object',
								 'inoplugs_version',
								 'inoplugs_string',
								 'inoplugs_array',
								 'inoplugs_exception',
								 'inoplugs_exceptions',
								 'inoplugs_query',
								 'inoplugs_stringparser');
		self::$classes_html = array('inoplugs_html');
	}

/**
 * This function is called by the parser when it finds a class, that is not loaded already.
 * To speed up, classes are only loaded, when actually needed.
 *
 * @param string $class_name		classname to load rendered by php-parser
 */
	static public function autoload($class_name)
	{
		$filepath = str_replace(basename( __FILE__),"",__FILE__);

		$path_framework_php = $filepath.'php/';
		$path_framework_html = $filepath.'htmlelements/';

		switch ($class_name)
		{
			case 'inoplugs_object':
			case 'inoplugs_version':
			case 'inoplugs_string':
			case 'inoplugs_array':
			case 'inoplugs_exception':
			case 'inoplugs_exceptions':
			case 'inoplugs_query':
			case 'inoplugs_stringparser':
				require_once "$path_framework_php$class_name.php";
				return;
				break;
			default:
				break;
		}

		switch ($class_name)
		{
			case 'inoplugs_html':
				require_once "$path_framework_html$class_name.php";
				return;
				break;
			default:
				break;
		}
	}


	/**
	 * This is a fallback funtion that loads all classfiles at startup, if
	 * the SPL autoload is not available.
	 */
	static public function load_all()
	{
				//	call constructor to fill array
		if(empty (self::$classes_php))
		{
			$o = new inoplugs_fw_loader_trial();
		}

		$filepath = str_replace(basename( __FILE__),"",__FILE__);

		$path_framework_php = $filepath.'php/';
		$path_framework_html = $filepath.'htmlelements/';
		foreach (self::$classes_php as $class_name)
		{
			if(! class_exists($class_name))
			{
				require_once "$path_framework_php$class_name.php";
			}
		}
		foreach (self::$classes_html as $class_name)
		{
			if(! class_exists($class_name))
			{
				require_once "$path_framework_html$class_name.php";
			}
		}
	}
}

/**
 * Fallback, if SPL is not activated
 */
if(function_exists(spl_autoload_register))
{
	spl_autoload_register('inoplugs_fw_loader_trial::autoload');
}
else
{
	inoplugs_fw_loader_trial::load_all();
}

?>
