<?php
/**
 * Contains static functions for string operations
 *
 * @author Schoenmann Guenter
 * @version 1.0.0.0
 */
class inoplugs_string extends inoplugs_object
{
	
	public function __construct(inoplugs_version $my_version = null, inoplugs_version $requ_version = null)
	{
		parent::__construct($my_version, $requ_version);
	}
    /**
	 *	Splits the string $content into substrings defined in array $key
	 *	and places the substrings in the array (numeric index).
	 *	No changes take place in the strings.
	 *
	 * @param string $string		the enclosed content to parse, is not altered
	 * @param array $arrkeys		array of values to split text
	 * @param bool $skipkey		true, if keywords should be removed
	 *								false keywords remain in array
	 * @return array				the splitted content,
	 *								index is numeric
	 */
	static public function split_string_by_key(&$string, &$arrkeys, $skipkey = false)
	{
		$arrpos = array();
		$i = 0;

					//	find the possible positions to split
		foreach ($arrkeys as $key => $value)
		{
			$anf = 0;
			do
			{
				$i = stripos($string, $value, $anf);
				if($i !== false)
				{
					$arrpos[$i] = $value;
					$anf = ++$i;
				}

			} while ($i !== false);
		}

				//	no matches found - returm complete string
		if(count($arrpos) == 0)
		{
			return array($string);
		}

		ksort($arrpos, SORT_NUMERIC);

		$arrsplited = array();

				//	split string
		reset($arrpos);
		$last = 0;

		while (current($arrpos) !== false)
		{
			$anf = key($arrpos);
			$key = current($arrpos);
			if($last < $anf)			//	first stringpart ??
			{
				$arrsplited[] = substr($string, $last, $anf);
			}

			$keyn = next($arrpos);
			if($keyn === false)		//	end of array
			{
				$end = strlen($string);
			}
			else
			{
				$end = key($arrpos);
			}

			if(!$skipkey)
			{
				$arrsplited[] = $key;
			}

			$anf += strlen($key);		//	skip keyword
			$len = $end - $anf;			//	length up to next keyword
			$arrsplited[] = substr($string, $anf, $len);
			$last = $end;
		}
		return $arrsplited;
	}

	/**
	 * Checks, if the given value is_string or is_numeric.
	 *
	 * @param mixed $value
	 * @return bool			true, if is_string or is_numeric
	 */
	static public function is_string_ex($value)
	{
		return (is_string($value) || is_numeric($value));
	}

}
?>
