<?php
/**
 *	Loaderclass to allow access to all classes required
 *
 * @author Schoenmann Guenter
 * @version 1.0.0.0
 */
class inoplugs_multiselect_loader_trial
{
	static $classes;

	public function __construct()
	{
		self::$classes = array('inoplugs_multiselect',
							 'inoplugs_multiselect_const',
							 'inoplugs_multiselect_parser');
	}
/**
 * This function is called by the parser when it finds a class, that is not loaded already.
 * To speed up, classes are only loaded, when actually needed.
 *
 * @param string $class_name		classname to load rendered by php-parser
 */
	static public function autoload($class_name)
	{
		$path_multiselect = str_replace(basename( __FILE__),"",__FILE__);

		switch ($class_name)
		{
			case 'inoplugs_multiselect':
			case 'inoplugs_multiselect_const':
			case 'inoplugs_multiselect_parser':
				require_once "$path_multiselect$class_name.php";
				return;
				break;
			default:
				break;
		}
	}

	/**
	 * This is a fallback funtion that loads all classfiles at startup, if
	 * the SPL autoload is not available.
	 */
	static public function load_all() 
	{
				//	call constructor to fill array
		if(empty (self::$classes))
		{
			$o = new inoplugs_multiselect_loader_trial();
		}

		$path_multiselect = str_replace(basename( __FILE__),"",__FILE__);
		foreach (self::$classes as $class_name)
		{
			if(! class_exists($class_name))
			{
				require_once "$path_multiselect$class_name.php";
			}
		}
	}
}

/**
 * Fallback, if SPL is not activated
 */
if(function_exists(spl_autoload_register))
{
	spl_autoload_register('inoplugs_multiselect_loader_trial::autoload');
}
else
{
	inoplugs_multiselect_loader_trial::load_all();
}

?>
