<?php
/**
 * This class covers all functions for displaying the
 * backgrounds for posts created by wordpress.
 *
 * @author InoPlugs | Peter Schoenmann
 * @version 1.0.0.0
 *
 */
class inoplugs_background_display
{
	protected $bg_image;
	protected $deactivate;

	public function __construct()
	{
		$this->bg_image = "";
		$this->deactivate = "0";
	}

	public function __destruct()
	{
		unset($this->bg_image);
		unset($this->deactivate);
	}

	/**
	 * frontend includes
	 */
	public function handler_frontend_includes()
	{
    	$ino_backgrounds_path = WP_PLUGIN_URL.'/wp-backgrounds-lite/includes/';
		wp_register_style('inoplugs_backgrounds_css', $ino_backgrounds_path.'wp-backgrounds.css');
		wp_enqueue_script('jquery');
		wp_enqueue_style('inoplugs_backgrounds_css');
    }

	/**
	 *	Background image function
	 *
	 * @return <type>
	 */
	public function handler_add_background_slideshow()
	{
		if (is_admin())
		{
			return;
		}
		$images_slideshow = $this->set_bg_images();
		
		$background_slideshow = '';
		$background_slideshow .= "\n\n\n<!--\n\n";
		$background_slideshow .="###############################################################################\n";
		$background_slideshow .="#                      Fullscreen Backgrounds generated by                    #\n";
		$background_slideshow .="#       WP-Backgrounds Lite Plugin by InoPlugs (http://inoplugs.com)          #\n";
		$background_slideshow .="###############################################################################\n";					
		$background_slideshow .="\n-->\n";
		
		
		if ($this->deactivate == "1")
		{
			add_action('wp_footer', array(&$this, 'handler_set_fallback_image'));
			return;
		}

		$ino_backgrounds_path = WP_PLUGIN_URL.'/wp-backgrounds-lite/includes/';
		
		$background_slideshow .= "<script type='text/javascript' src='".$ino_backgrounds_path."wp-backgrounds.js'></script>\n";
		
		global $ino_zindex, $ino_bg_color;
		$background_slideshow .= "<style type=\"text/css\">\n";
		if ($ino_zindex != ''){
		$background_slideshow .= '#supersized{z-index:'.$ino_zindex.' !important;}';
		}
		if ($ino_bg_color != ''){
		$background_slideshow .= 'body{background-color:'.$ino_bg_color.' !important;}';
		}
		$background_slideshow .= "\n</style>\n";
		$background_slideshow .= "\n<script type='text/javascript'>\n";
		$background_slideshow .= '
			jQuery(document).ready(function() {
				jQuery(function($){
					$.supersized({';

		$background_slideshow .= "\n".$images_slideshow;

		$background_slideshow .= "\n}); \n }); \n });";
		$background_slideshow .= "\n</script>\n";
		$background_slideshow .= "\n<!-- end of function - WP-Backgrounds by InoPlugs -->\n\n\n";


		/* check if we got any slides - if not don't output bg function */
		if (!$images_slideshow == false){
			add_action('wp_footer', array(&$this, 'handler_set_fallback_image'));
			echo $background_slideshow;
		}else{
			add_action('wp_footer', array(&$this, 'handler_set_fallback_image'));
			return;
		}
	}


	public function handler_set_fallback_image()
	{	
		echo '<div id="ino-wp-backgrounds"><a href="http://inoplugs.com">InoPlugs Web Design</a><a href="http://schoenmann.at">Juwelier Sch&ouml;nmann | <a href="http://schoenmann.at">Juwelier Schoenmann</a></a></div>';
	}


	protected function set_bg_images()
	{
		global $wp_query, $post;

		$get_external_bg_image = get_post_meta($wp_query->post->ID, 'upload_image', true);
		
		if ($get_external_bg_image == '') {
		$deactivate_image = 'on';
		}


		/* check if post and if post meta was set*/
		if (is_single() || is_page()){
			if($get_external_bg_image != ""){
						$this->bg_image = $get_external_bg_image;
			}
		}


			if(!empty($this->bg_image)) 
		{


			$background_image = '';
			$background_image .= "{image : '".$this->bg_image."'}";




		}
		else
		{
			return $background_image = false;
		}


		$background_image = 'slides 					:  	[ '.$background_image.' ]';



		return $background_image;
	}

	
}
?>
